CREATE PROCEDURE spIns_szervezeti_egyseg
AS
BEGIN
	-- 1) Vltozk deklarcija
	DECLARE @nev_szervEgys VARCHAR(250),
		    @szulo_id_szervEgys INT
	DECLARE @aktiv_szervEgys BIT,
			@id_lekRekord INT,
			@aktiv_lekRekord BIT

	-- 2) Vltozk rtkadsa
	-- 2.1) Konkrt rtkads
	SET @nev_szervEgys = 'Eszterhzy Kroly Egyetem'
	-- 2.2) Valamilyen tbla egy mezjt, vagy egy fggvny vissztr. rtkt olassuk ki
	SELECT @szulo_id_szervEgys = id
	FROM szervezeti_egysegek
	WHERE nev = @nev_szervEgys

	SET @nev_szervEgys = 'Eszterhzy Kroly Egyetem'
	SET @szulo_id_szervEgys = null
	SET @aktiv_szervEgys = 1

	-- Feladat 1: Ellenrizzk le, hogy a @nev_szervEgys vltozban megadott
	-- nev szervezeti egysg ltezik-e mr az adatbzisban. 
	-- F1.1: Ha nem, akkor adjuk hozz a DB-hez.
	-- F2.2: Ha igen, s a szervezeti egysg inaktv, akkor tegyk aktvv

	-- EXISTS(SELECT * FROM szervezeti_egysegek WHERE nev = @nev_szervEgys)
	-- Akkor j, ha az exists parmtereknt lert lekrdezs eredmnyhalmaznak 
	-- mezire nincs szksg
	-- ==> itt nem lesz j, mivel az IF gban kulcs alapjn frisstenem kell
	-- Elbb krdezzk le a mezk rtkt, s azt vizsglva dntsnk!!!

	SELECT @id_lekRekord = id, @aktiv_lekRekord = aktiv
	FROM szervezeti_egysegek
	WHERE nev = @nev_szervEgys;

	IF @id_lekRekord IS NOT NULL  BEGIN
		IF @aktiv_lekRekord = 0 BEGIN
			UPDATE szervezeti_egysegek
			SET aktiv = 1
			WHERE id = @id_lekRekord
		END
	END ELSE BEGIN
		INSERT INTO szervezeti_egysegek(nev, szulo_id, aktiv)
		VALUES (@nev_szervEgys, @szulo_id_szervEgys, @aktiv_szervEgys)
	END

END